package com.jpsoft.smart.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import com.github.pagehelper.util.StringUtil;
import com.jpsoft.smart.modules.base.service.DeviceInfoService;
import com.jpsoft.smart.modules.base.service.impl.DeviceInfoServiceImpl;
import com.jpsoft.smart.modules.sys.dao.DataDictionaryDAO;
import com.jpsoft.smart.modules.sys.service.DataDictionaryService;
import com.jpsoft.smart.modules.sys.service.impl.DataDictionaryServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

import javax.annotation.Resource;

/**
  描述:base_device_info的实体类
 */
@Data
@ApiModel(value = "base_device_info的实体类")
public class DeviceInfo {
	/**
	 *ID
	 */
	@ApiModelProperty(value = "ID")
	private String id;
	/**
	 *表头
	 */
	@ApiModelProperty(value = "表头")
	private String header;
	/**
	 *设备编号
	 */
	@ApiModelProperty(value = "设备编号")
	private String deviceNo;
	/**
	 *设备别名
	 */
	@ApiModelProperty(value = "设备别名")
	private String aliasName;
	/**
	 *单元楼栋
	 */
	@ApiModelProperty(value = "单元楼栋")
	private String address;
	/**
	 *运行状态（是否在线）
	 */
	@ApiModelProperty(value = "运行状态（是否在线）")
	private Boolean isOnline;
	/**
	 *运行状态（是否在线）
	 */
	private String isOnlineN;

    /**
     *公司ID
     */
    @ApiModelProperty(value = "公司ID")
    private String companyId;

	/**
	 *公司名称
	 */
	@ApiModelProperty(value = "公司名称")
	private String companyName;

	/**
	 *开锁密码
	 */
        @ApiModelProperty(value = "开锁密码")
	private String unlockPassword;
	/**
	 *二维码地址
	 */
        @ApiModelProperty(value = "二维码地址")
	private String codeAddress;
	/**
	 *ip地址
	 */
        @ApiModelProperty(value = "ip地址")
	private String ipAddress;
	/**
	 *端口
	 */
        @ApiModelProperty(value = "端口")
	private String port;
	/**
	 *类型
	 */
	@ApiModelProperty(value = "类型")
	private String type;

	/**
	 *类型
	 */
	@ApiModelProperty(value = "类型")
	private String typeN;
	/**
	 *是否开启自动更新
	 */
	@ApiModelProperty(value = "是否开启自动更新")
	private Boolean isAutoUpdate;

	@ApiModelProperty(value = "是否开启自动更新")
	private String isAutoUpdateN;
	/**
	 *是否删除
	 */
        @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	@ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;


	@ApiModelProperty(value = "是否绑定人员(只做查询作用，不写入数据库)")
	private Boolean isBindPerson;

	@ApiModelProperty(value = "默认人脸库id")
	private String defaultFaceLibraryId;

	public String getIsOnlineN() {
		if(isOnline!=null) {
			if (isOnline) {
				isOnlineN = "在线";
			} else {
				isOnlineN = "离线";
			}
		}
		return isOnlineN;
	}

	public String getIsAutoUpdateN() {
		if(isAutoUpdate!=null) {
			if (isAutoUpdate) {
				isAutoUpdateN = "是";
			} else {
				isAutoUpdateN = "否";
			}
		}
		return isAutoUpdateN;
	}


}