package com.jpsoft.smart.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_person_info的实体类
 */
@Data
@ApiModel(value = "base_person_info的实体类")
public class PersonInfo {
    /**
     * 编号
     */
    @ApiModelProperty(value = "编号")
    private Long id;
    /**
     * 企业编号
     */
    @ApiModelProperty(value = "企业编号")
    private String companyId;
    /**
     * 企业名称
     */
    @ApiModelProperty(value = "企业名称")
    private String companyName;
    /**
     * 姓名
     */
    @ApiModelProperty(value = "姓名")
    private String name;
    /**
     * 手机号
     */
    @ApiModelProperty(value = "手机号")
    private String phone;
    /**
     * 身份证号
     */
    @ApiModelProperty(value = "身份证号")
    private String idCard;
    /**
     * 微信openId
     */
    @ApiModelProperty(value = "微信openId")
    private String openId;
    /**
     * 人脸
     */
    @ApiModelProperty(value = "人脸")
    private Boolean faceEnabled;

    @ApiModelProperty(value = "是否已将人脸信息传给终端")
    private Boolean faceBound;

    /**
     * 刷卡
     */
    @ApiModelProperty(value = "刷卡")
    private Boolean cardEnabled;
    /**
     * 手机
     */
    @ApiModelProperty(value = "手机")
    private Boolean appEnabled;
    /**
     * 密码
     */
    @ApiModelProperty(value = "密码")
    private Boolean passwordEnabled;
    /**
     * 访客
     */
    @ApiModelProperty(value = "访客")
    private Boolean guestEnabled;
    /**
     * 位置1
     */
    @ApiModelProperty(value = "位置1")
    private String position1;
    /**
     * 位置2
     */
    @ApiModelProperty(value = "位置2")
    private String position2;
    /**
     * 位置3
     */
    @ApiModelProperty(value = "位置3")
    private String position3;
    /**
     * 位置4
     */
    @ApiModelProperty(value = "位置4")
    private String position4;
    /**
     * 位置5
     */
    @ApiModelProperty(value = "位置5")
    private String position5;
    /**
     * 是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    @ApiModelProperty(value = "人脸相片地址")
    private String faceImageUrl;

}