package com.jpsoft.smart.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import javax.annotation.Resource;

import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.jpsoft.smart.modules.base.dao.DeviceInfoDAO;
import com.jpsoft.smart.modules.base.entity.DeviceInfo;
import com.jpsoft.smart.modules.base.service.DeviceInfoService;
import com.github.pagehelper.Page;
import com.jpsoft.smart.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Slf4j
@Transactional
@Component(value="deviceInfoService")
public class DeviceInfoServiceImpl implements DeviceInfoService {
	@Resource(name="deviceInfoDAO")
	private DeviceInfoDAO deviceInfoDAO;

	@Override
	public DeviceInfo get(String id) {
		// TODO Auto-generated method stub
		return deviceInfoDAO.get(id);
	}

	@Override
	public int insert(DeviceInfo model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());

		return deviceInfoDAO.insert(model);
	}

	@Override
	public int update(DeviceInfo model) {
		// TODO Auto-generated method stub
		return deviceInfoDAO.update(model);
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return deviceInfoDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = deviceInfoDAO.exist(id);

		return count > 0 ? true : false;
	}

	@Override
	public List<DeviceInfo> list() {
		// TODO Auto-generated method stub
		return deviceInfoDAO.list();
	}

	@Override
	public DeviceInfo getByDeviceNo(String deviceNo){
		return deviceInfoDAO.getByDeviceNo(deviceNo);
	}

	@Override
	public List<DeviceInfo> findByCompanyId(String companyId){
		return deviceInfoDAO.findByCompanyId(companyId);
	}

	@Override
	public Page<DeviceInfo> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<DeviceInfo> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            deviceInfoDAO.search(searchParams,sortList);
        });

        return page;
	}

	@Override
	public void updateByDeviceNo(String deviceNo, String ip) {
		DeviceInfo deviceInfo= deviceInfoDAO.findByDeviceNo(deviceNo);
		String oldIp = deviceInfo.getIpAddress();
		if (deviceInfo.getIsAutoUpdate() && !deviceInfo.getIpAddress().equals(ip)){
			deviceInfo.setIpAddress(ip);
			deviceInfoDAO.update(deviceInfo);
			log.warn(deviceNo+"的ip由原来的："+oldIp+"自动更新为："+ip);
		}

	}
}