package com.jpsoft.smart.modules.base.service.impl;

import cn.hutool.json.JSONObject;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.jpsoft.smart.config.OSSConfig;
import com.jpsoft.smart.modules.base.dao.AlarmInfoDAO;
import com.jpsoft.smart.modules.base.dao.PersonDeviceLogDAO;
import com.jpsoft.smart.modules.base.entity.PersonDeviceLog;
import com.jpsoft.smart.modules.base.service.PersonDeviceLogService;
import com.jpsoft.smart.modules.common.dto.Sort;
import com.jpsoft.smart.modules.common.utils.BASE64DecodedMultipartFile;
import com.jpsoft.smart.modules.common.utils.Base64;
import com.jpsoft.smart.modules.common.utils.LApiUtil;
import com.jpsoft.smart.modules.common.utils.OSSUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;
import sun.misc.BASE64Decoder;

import javax.annotation.Resource;
import javax.xml.crypto.Data;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.UUID;

/**
 * @author 墨鱼_mo
 * @date 2020-3-15 14:12
 */
@Slf4j
@Transactional
@Component(value="personDeviceLogService")
public class PersonDeviceLogServiceImpl implements PersonDeviceLogService {

    @Autowired
    private OSSConfig ossConfig;

    @Resource(name="personDeviceLogDAO")
    private PersonDeviceLogDAO personDeviceLogDAO;

    /*@Override
    public void deviceInsertLog(String deviceNo, BigDecimal temperature, JSONObject faceImageJson, JSONObject libMatInfoListJson, JSONObject matchPersonInfo, Data data) {
        PersonDeviceLog personDeviceLog = new PersonDeviceLog();
        personDeviceLog.setId(UUID.randomUUID().toString());
        personDeviceLog.setDeviceNo(deviceNo);
        personDeviceLog.setPersonId(matchPersonInfo.getStr("PersonCode"));
        personDeviceLog.setTemperature(temperature);
        personDeviceLog.setMatchStatus(libMatInfoListJson.getInt("MatchStatus"));
        personDeviceLog.setMatchMsg(IApiUtil.getMatchMsg(libMatInfoListJson.getInt("MatchStatus")));
        personDeviceLog.setMatchFaceId(libMatInfoListJson.getInt("MatchFaceID"));
        personDeviceLog.setRecordTime(data);


    }*/

    @Override
    public void deviceInsertLog(String deviceNo, BigDecimal temperature, JSONObject faceImageJson, JSONObject libMatInfoListJson, JSONObject matchPersonInfo, Date date)  {
        String retFileUrl = "";
        try{

            BASE64Decoder decoder = new BASE64Decoder();

            byte[] imgData = decoder.decodeBuffer(faceImageJson.getStr("Data"));

            for (int i = 0; i < imgData.length; ++i) {
                if (imgData[i] < 0) {// 调整异常数据
                    imgData[i] += 256;
                }
            }

            ByteArrayInputStream inputStream = new ByteArrayInputStream(imgData);



             retFileUrl = OSSUtil.upload(ossConfig,"/devicePersonLog",faceImageJson.getStr("Name"), inputStream);
        }catch (Exception e){
            e.printStackTrace();
        }


        PersonDeviceLog personDeviceLog = new PersonDeviceLog();
        personDeviceLog.setId(UUID.randomUUID().toString());
        personDeviceLog.setDeviceNo(deviceNo);
        if (!libMatInfoListJson.getStr("MatchPersonID").equals("0") && StringUtils.isNotBlank(matchPersonInfo.getStr("PersonCode"))){
            personDeviceLog.setPersonId(matchPersonInfo.getInt("PersonCode"));
        }else if (!libMatInfoListJson.getStr("MatchPersonID").equals("0") && StringUtils.isBlank(matchPersonInfo.getStr("PersonCode")) && StringUtils.isNotBlank(matchPersonInfo.getStr("PersonName"))){
            String personName = matchPersonInfo.getStr("PersonName");
            if (personName.contains("_")){
                log.warn(personName+"校验成功但未找到personCode");
                Integer personId =Integer.valueOf(personName.substring(personName.indexOf("_")+1)) ;
                personDeviceLog.setPersonId(personId);
            }else {
                log.warn(personName+"校验成功但姓名中无personCode后缀");
                personDeviceLog.setPersonId(0);
            }


        }

        else {
            personDeviceLog.setPersonId(0);
        }

        personDeviceLog.setTemperature(temperature);
        if (StringUtils.isNotBlank(libMatInfoListJson.getStr("MatchStatus"))){
            personDeviceLog.setMatchStatus(libMatInfoListJson.getInt("MatchStatus"));
            personDeviceLog.setMatchMsg(LApiUtil.getMatchMsg(libMatInfoListJson.getInt("MatchStatus")));
            personDeviceLog.setMatchFaceId(libMatInfoListJson.getInt("MatchFaceID"));
        }else {
            personDeviceLog.setMatchStatus(0);
            personDeviceLog.setMatchFaceId(0);
        }

        personDeviceLog.setRecordTime(date);
        personDeviceLog.setDelFlag(false);
        personDeviceLog.setCreateTime(new Date());
        personDeviceLog.setFaceImage(retFileUrl);
        personDeviceLogDAO.insert(personDeviceLog);
    }

    @Override
    public Page<PersonDeviceLog> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<PersonDeviceLog> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            personDeviceLogDAO.search(searchParams,sortList);
        });

        return page;
    }



}
