package com.jpsoft.smart.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.jpsoft.smart.modules.base.dao.PersonDeviceRelationDAO;
import com.jpsoft.smart.modules.base.entity.PersonDeviceRelation;
import com.jpsoft.smart.modules.base.service.PersonDeviceRelationService;
import com.github.pagehelper.Page;
import com.jpsoft.smart.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="personDeviceRelationService")
public class PersonDeviceRelationServiceImpl implements PersonDeviceRelationService {
	@Resource(name="personDeviceRelationDAO")
	private PersonDeviceRelationDAO personDeviceRelationDAO;

	@Override
	public PersonDeviceRelation get(String id) {
		// TODO Auto-generated method stub
		return personDeviceRelationDAO.get(id);
	}

	@Override
	public int insert(PersonDeviceRelation model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());

		return personDeviceRelationDAO.insert(model);
	}

	@Override
	public int update(PersonDeviceRelation model) {
		// TODO Auto-generated method stub
		return personDeviceRelationDAO.update(model);
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return personDeviceRelationDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = personDeviceRelationDAO.exist(id);

		return count > 0 ? true : false;
	}

	@Override
	public List<PersonDeviceRelation> list() {
		// TODO Auto-generated method stub
		return personDeviceRelationDAO.list();
	}

	@Override
	public List<PersonDeviceRelation> findByPersonId(Long personId){
		return personDeviceRelationDAO.findByPersonId(personId);
	}

	@Override
	public List<PersonDeviceRelation> findByDeviceId(String deviceId){
		return personDeviceRelationDAO.findByDeviceId(deviceId);
	}

	@Override
	public PersonDeviceRelation findByDeviceIdAndPersonId(String deviceId,Long personId){
		return personDeviceRelationDAO.findByDeviceIdAndPersonId(deviceId,personId);
	}



	@Override
	public Page<PersonDeviceRelation> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<PersonDeviceRelation> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            personDeviceRelationDAO.search(searchParams,sortList);
        });

        return page;
	}

//	@Override
//	public List<PersonDeviceRelation> findByPersonId(Long id) {
//
//		return personDeviceRelationDAO.findByPersonId(id);
//	}
}