package com.jpsoft.smart.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.jpsoft.smart.modules.base.dao.PersonInfoDAO;
import com.jpsoft.smart.modules.base.entity.PersonInfo;
import com.jpsoft.smart.modules.base.service.PersonInfoService;
import com.github.pagehelper.Page;
import com.jpsoft.smart.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="personInfoService")
public class PersonInfoServiceImpl implements PersonInfoService {
	@Resource(name="personInfoDAO")
	private PersonInfoDAO personInfoDAO;

	@Override
	public PersonInfo get(Long id) {
		// TODO Auto-generated method stub
		return personInfoDAO.get(id);
	}

	@Override
	public int insert(PersonInfo model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());
		
		return personInfoDAO.insert(model);
	}

	@Override
	public int update(PersonInfo model) {
		// TODO Auto-generated method stub
		return personInfoDAO.update(model);		
	}

	@Override
	public int delete(Long id) {
		// TODO Auto-generated method stub
		return personInfoDAO.delete(id);
	}

	@Override
	public boolean exist(Long id) {
		// TODO Auto-generated method stub
		int count = personInfoDAO.exist(id);
		
		return count > 0 ? true : false;
	}
	
	@Override
	public List<PersonInfo> list() {
		// TODO Auto-generated method stub
		return personInfoDAO.list();
	}
		
	@Override
	public Page<PersonInfo> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<PersonInfo> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            personInfoDAO.search(searchParams,sortList);
        });
        
        return page;
	}

	@Override
	public PersonInfo findByNameAndPhone(String name, String phone) {
		return personInfoDAO.findByNameAndPhone(name,phone);
	}

	@Override
	public PersonInfo findByOpenId(String openId) {
		return personInfoDAO.findByOpenId(openId);
	}
}