package com.jpsoft.smart.modules.common.utils;

import com.jpsoft.smart.modules.wechat.entity.AccessToken;
import net.sf.json.JSONObject;
import org.apache.commons.lang3.StringUtils;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class WechatMessageUtil {


	
	public static final String send_template = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=ACCESS_TOKEN";
	




	private static final String TEMPLATE_REDIRECT_PRE_URL = "http://wuyeopenlocktest-wecat.sudaonline.net";


	
	

	public static boolean sendBillInfo(String fullName, BigDecimal amount, String openId,
									   String detailAmount, String propertyName, String billRemark, String billDetailId,String billTemplateId,String appId,String appSecret) {


		JSONObject sendData = new JSONObject();
		
		JSONObject first = new JSONObject();
		first.put("value", "您有一个新的账单，点击查看详情！");
		first.put("color", "#FF0000");
		
		JSONObject keyword1 = new JSONObject();
		keyword1.put("value", fullName);
		keyword1.put("color", "#173177");

		JSONObject keyword2 = new JSONObject();
		keyword2.put("value", "￥" + amount.setScale(2) + "元");
		keyword2.put("color", "#173177");

		JSONObject keyword3 = new JSONObject();
		keyword3.put("value", detailAmount);
		keyword3.put("color", "#173177");



		String remarkStr = "账单来源：" + propertyName;
		
		if(StringUtils.isNotBlank(billRemark)){
			remarkStr = remarkStr + "\n备注："+ billRemark +"";
		}
		
		JSONObject remark = new JSONObject();
		remark.put("value", remarkStr);
		remark.put("color", "#173177");
		
		sendData.put("first", first);
		sendData.put("keyword1", keyword1);
		sendData.put("keyword2", keyword2);
		sendData.put("keyword3", keyword3);
		sendData.put("remark", remark);
		
		//w8Zk_VQMFIEVSIBPZid7zSrvHmBdrgnqF76u8PLCZEs cs
		boolean ret = sendTemplate(sendData, appId,appSecret,billTemplateId,openId, TEMPLATE_REDIRECT_PRE_URL + "/billDetail/" + billDetailId +"payTime=0&payType=bill");
				
		return ret;
	}
	
	//
	public static boolean sendBillPayedMessage(String fullName,String feeName,Date createTime,BigDecimal amount,String openId,String billDetailId,String payedTemplateId,String appId,String appSecret) {

		JSONObject sendData = new JSONObject();
		
		JSONObject first = new JSONObject();
		first.put("value", "账单支付成功！");
		first.put("color", "#FF0000");
		
		JSONObject keyword1 = new JSONObject();
		keyword1.put("value", fullName);
		keyword1.put("color", "#173177");
		
		JSONObject keyword2 = new JSONObject();
		keyword2.put("value", feeName);
		keyword2.put("color", "#173177");


		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

		JSONObject keyword3 = new JSONObject();
		keyword3.put("value", sdf.format(createTime));
		keyword3.put("color", "#173177");
		
		JSONObject keyword4 = new JSONObject();
		
		keyword4.put("value", "￥" + amount.setScale(2) + "元");
		keyword4.put("color", "#173177");
		

		

		
		String remarkStr = "感谢您的支持，点击查看缴费详情";
		
		JSONObject remark = new JSONObject();
		remark.put("value", remarkStr);
		remark.put("color", "#173177");
		
		sendData.put("first", first);
		sendData.put("keyword1", keyword1);
		sendData.put("keyword2", keyword2);
		sendData.put("keyword3", keyword3);
		sendData.put("keyword4", keyword4);
		sendData.put("remark", remark);
		
		//w8Zk_VQMFIEVSIBPZid7zSrvHmBdrgnqF76u8PLCZEs cs
		boolean ret = sendTemplate(sendData,appId,appSecret,payedTemplateId ,openId,TEMPLATE_REDIRECT_PRE_URL + "/billDetail/" + billDetailId +"payTime=1&payType=bill");
				
		return ret;
	}
	
	//
	public static boolean sendScanPayedMessage(String fullName,String feeName,Date createTime,BigDecimal amount,String openId,String independentPayId,String payedTemplateId,String appId,String appSecret) {

		JSONObject sendData = new JSONObject();

		JSONObject first = new JSONObject();
		first.put("value", "账单支付成功！");
		first.put("color", "#FF0000");

		JSONObject keyword1 = new JSONObject();
		keyword1.put("value", fullName);
		keyword1.put("color", "#173177");

		JSONObject keyword2 = new JSONObject();
		keyword2.put("value", feeName);
		keyword2.put("color", "#173177");


		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

		JSONObject keyword3 = new JSONObject();
		keyword3.put("value", sdf.format(createTime));
		keyword3.put("color", "#173177");

		JSONObject keyword4 = new JSONObject();

		keyword4.put("value", "￥" + amount.setScale(2) + "元");
		keyword4.put("color", "#173177");





		String remarkStr = "感谢您的支持，点击查看缴费详情";

		JSONObject remark = new JSONObject();
		remark.put("value", remarkStr);
		remark.put("color", "#173177");

		sendData.put("first", first);
		sendData.put("keyword1", keyword1);
		sendData.put("keyword2", keyword2);
		sendData.put("keyword3", keyword3);
		sendData.put("keyword4", keyword4);
		sendData.put("remark", remark);

		boolean ret = sendTemplate(sendData,appId,appSecret,payedTemplateId ,openId,TEMPLATE_REDIRECT_PRE_URL + "/billDetail/" + independentPayId +"payTime=1&payType=wechat");

		return ret;
	}
	
	/**
	 * 发送通知信息
	 * @param noticeName 通知名称名称
	 * @param noticeDetailId 通知详情ID
	 * @param openId 发送人
	 * @return
	 */
	public static boolean sendNoticeMessage(String noticeName,String content,String openId,String noticeDetailId,String noticeTemplateId,String appId,String appSecret) {


		JSONObject sendData = new JSONObject();
		String finallyContent = getContent(content);
		JSONObject first = new JSONObject();
		first.put("value", "您好，园区通知如下：");
		first.put("color", "#173177");
		
		JSONObject keyword1 = new JSONObject();
		keyword1.put("value", noticeName);
		keyword1.put("color", "#173177");
		

		
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		
		JSONObject keyword2 = new JSONObject();
		keyword2.put("value", sdf.format(new Date()));
		keyword2.put("color", "#173177");
		
		JSONObject keyword3 = new JSONObject();
		keyword3.put("value", finallyContent);
		keyword3.put("color", "#173177");
		
		JSONObject remark = new JSONObject();
		remark.put("value", "点击查看详情");
		remark.put("color", "#173177");
		
		sendData.put("first", first);
		sendData.put("keyword1", keyword1);
		sendData.put("keyword2", keyword2);
		sendData.put("keyword3", keyword3);
		sendData.put("remark", remark);
		
		//noticeDetailId
		boolean ret = sendTemplate(sendData,appId,appSecret,noticeTemplateId ,openId, TEMPLATE_REDIRECT_PRE_URL + "/#/noticeInfo/" + noticeDetailId);
				
		return ret;
	}

	/**
	 * 发送物业管理通知信息
	 * @param noticeName 通知名称
	 * @param noticeDetailId 通知详情ID
	 * @param openId 发送人
	 * @return
	 */
	public static boolean sendPropertyNoticeMessage(String noticeName,String content,String openId,String noticeDetailId,String noticeTemplateId,String appId,String appSecret) {


		JSONObject sendData = new JSONObject();
		String finallyContent = getContent(content);
		JSONObject first = new JSONObject();
		first.put("value", "您好，物业管理通知如下：");
		first.put("color", "#173177");

		JSONObject keyword1 = new JSONObject();
		keyword1.put("value", noticeName);
		keyword1.put("color", "#173177");



		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

		JSONObject keyword2 = new JSONObject();
		keyword2.put("value", sdf.format(new Date()));
		keyword2.put("color", "#173177");

		JSONObject keyword3 = new JSONObject();
		keyword3.put("value", finallyContent);
		keyword3.put("color", "#173177");

		JSONObject remark = new JSONObject();
		remark.put("value", "点击查看详情");
		remark.put("color", "#173177");

		sendData.put("first", first);
		sendData.put("keyword1", keyword1);
		sendData.put("keyword2", keyword2);
		sendData.put("keyword3", keyword3);
		sendData.put("remark", remark);

		//noticeDetailId
		boolean ret = sendTemplate(sendData,appId,appSecret,noticeTemplateId ,openId, TEMPLATE_REDIRECT_PRE_URL + "/#/noticeInfo/" + noticeDetailId);

		return ret;
	}

	/**
	 * 发送警告通知信息
	 * @param noticeName 通知名称
	 * @param noticeDetailId 通知详情ID
	 * @param openId 发送人
	 * @return
	 */
	public static boolean sendAlarmNoticeMessage(String noticeName,String content,Date createTime,String openId,String noticeDetailId,String noticeTemplateId,String appId,String appSecret) {


		JSONObject sendData = new JSONObject();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String finallyContent = getContent(content);
		JSONObject first = new JSONObject();
		first.put("value", "您好，入侵警告通知如下：");
		first.put("color", "#173177");

		JSONObject keyword1 = new JSONObject();
		keyword1.put("value", sdf.format(createTime));
		keyword1.put("color", "#173177");


		JSONObject keyword2 = new JSONObject();
		keyword2.put("value", finallyContent);
		keyword2.put("color", "#173177");

		JSONObject remark = new JSONObject();
		remark.put("value", "请尽快查看");
		remark.put("color", "#173177");

		sendData.put("first", first);
		sendData.put("keyword1", keyword1);
		sendData.put("keyword2", keyword2);
		//sendData.put("remark", remark);

		//noticeDetailId
		boolean ret = sendTemplate(sendData,appId,appSecret,noticeTemplateId ,openId, "");

		return ret;
	}
	
	/**
	 * 微信发送模版
	 * @param sendData 发送数据
	 * @param templateId 模版Id
	 * @param openId 发送人
	 * @param url 详情跳转地址
	 * @return
	 */
	private static boolean sendTemplate(JSONObject sendData,String appId,String appSecret,String templateId,String openId,String url){
		
		boolean result = false;


		AccessToken accessToken = WeixinUtil.getAccessToken(appId, appSecret);
		
		if(accessToken != null){
			//发送模版内容
			String sendTemplateUrl = send_template.replace("ACCESS_TOKEN", accessToken.getToken());
			
			JSONObject sendTemplateData = new JSONObject();
			
			sendTemplateData.put("touser", openId);
			sendTemplateData.put("template_id", templateId);
			sendTemplateData.put("url", url);
			sendTemplateData.put("data", sendData);
			
			System.out.println("模版发送Id>>>>" + templateId + ">>>模版发送数据>>>>>" + sendTemplateData.toString());
			
			String sendTemplateRet =  HttpConnectionUtil.requestByPost(sendTemplateUrl, sendTemplateData.toString());
			
			System.out.println("模版发送返回数据>>>>>" + sendTemplateRet);
			
			if(StringUtils.isNotBlank(sendTemplateRet)){
				JSONObject sendTemplateJson = JSONObject.fromObject(sendTemplateRet);
				
				if("0".equals(sendTemplateJson.getString("errcode"))){
					//发送成功
					result = true;
				}
			}
		}
		
		return result;
	}

	public static String getContent(String content){
		String finallyContent = content;
		String regex="<p.*?>(.*?)</p>";
		Pattern p =Pattern.compile(regex);
		Matcher m=p.matcher(content);
		while(m.find()){
			finallyContent =  m.group(1);
		}



		return finallyContent;
	}
	

		
	public static void main(String[] args) {
		/*AccessToken at = WeixinUtil.getAccessToken(APP_ID, APP_SECRET,"061iw9gy1sZ1dg09dqhy1ae3gy1iw9gq");
		
		System.out.println(at.getOpenid());*/
		
		/*for (int i = 0; i < 1; i++) {
			doorMessage("1111", 2,"2018-09-22 09:00-12:00", 1, "2222222", "3333333", "oiFbN0p9jKphExeGIa3HtyL9HjqM");
		}*/
		
		//orderConfirmMessage("12312321312", 1111, DEFAULT_OPEN_ID);
		//sendBillInfo("测试", "测sendNoticeMessage试", "荆鹏创业", "张三", new BigDecimal(1), "o64fbt6TTUcqLC_tyVJ60I5kzWVc", "1111", new Date());
		//sendBillPayedMessage("测试", "荆鹏创业", "张三", new BigDecimal(1), "o64fbt6TTUcqLC_tyVJ60I5kzWVc", "11111", new Date());
		//sendScanPayedMessage("测试", "荆鹏创业", "张三11111", new BigDecimal(1), "o64fbt6TTUcqLC_tyVJ60I5kzWVc", "11111", new Date());
//sendNoticeMessage("测试", "sdfsdfasfasdfafasdfasdf", "oHjCawgwCGen5k1-hAsimdEX5lZo", "2222","9JKu9t9uTPHL1siIm7WatOJ1KXGolzEPlnmqIbckTUM","wx41ac6791b9dbcf52","3e3d47c5f132d4b47636a536d503fbd4");

	/*	sendBillInfo("1栋-1单元-101",new BigDecimal("0.01"),"oOlFd1BUR6Fi2ayBWUeou81G8ZD4",
				"物业费","小鹏物业","测试","9e52c923-2179-4526-a108-32becc9aa1d0","vVraOPl4OyNVWDGz6XYlJqRb7qGjjcyJdnVi5HWmFRI","wx41ac6791b9dbcf52","3e3d47c5f132d4b47636a536d503fbd4");*/

		/*sendBillPayedMessage("1栋-1单元-101","物业费",new Date(),new BigDecimal("0.01"),"oOlFd1BUR6Fi2ayBWUeou81G8ZD4","33e7e5e6-5b38-45f5-9ccf-c7ef21978a5b","kbx5u70nzo7PklTVl4B1xvRffksrUtXxnDll8ggEKlo","wx41ac6791b9dbcf52","3e3d47c5f132d4b47636a536d503fbd4");*/

		//sendAlarmNoticeMessage("周界入侵警报", "周界入侵，目标ID：1419，区域范围：(0.327,0.698)(0.674,0.936)(0.67,0.985)(0.352,0.973)", "oHjCawgwCGen5k1-hAsimdEX5lZo", "","8dpP8XM1XaiiIByXiuAeFIZeNjEow1AleG_h8O2xyVA","wx7e70eb62a8459869","909d17e353268da57c4f18cc09798049");
		//sendNoticeMessage("测试", "sdfsdfasfasdfafasdfasdf", "oHjCawgwCGen5k1-hAsimdEX5lZo", "2222","vsw6sb9lMA3bcsE8MdeaGENvI1HSUy2ht9B8hS3jEzA","wx7e70eb62a8459869","909d17e353268da57c4f18cc09798049");
		getContent("<p>内容</p>");

	}


	
	
}
