package com.jpsoft.smart.electricity.server;

import com.jpsoft.smart.electricity.server.protocol.MeterReceivePacket;
import io.netty.channel.Channel;

import java.util.Map;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.ConcurrentHashMap;

public class ChannelWrapper {
    private Channel channel;
    //一个通道可能对应多个电表
    private Map<String,BlockingQueue<MeterReceivePacket>> receivePacketQueueMap;

    public ChannelWrapper(Channel channel){
        this.channel = channel;
        this.receivePacketQueueMap = new ConcurrentHashMap<>();
    }

    public Channel getChannel() {
        return channel;
    }

    public BlockingQueue<MeterReceivePacket> getReceivePacketQueue(String key) {

       if(!this.receivePacketQueueMap.containsKey(key)){
           BlockingQueue<MeterReceivePacket> queue =  new ArrayBlockingQueue<>(100);
           receivePacketQueueMap.put(key,queue);
       }

       return this.receivePacketQueueMap.get(key);
    }
}
