package com.jpsoft.smart.electricity.server;

import com.jpsoft.smart.electricity.server.codec.MeterDecodeHandler;
import com.jpsoft.smart.electricity.server.codec.MeterEncodeHandler;
import com.jpsoft.smart.electricity.server.handler.ActiveChannelHandler;
import com.jpsoft.smart.electricity.server.handler.HeartbeatServerHandler;
import com.jpsoft.smart.electricity.server.handler.IMIdleStateHandler;
import com.jpsoft.smart.electricity.server.handler.MeterServerHandler;
import io.netty.channel.Channel;
import io.netty.channel.ChannelInitializer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class ServerChannelInitializer extends ChannelInitializer{
    @Autowired
    private ActiveChannelHandler activeChannelHandler;

    @Autowired
    private MeterServerHandler meterServerHandler;

    @Autowired
    private HeartbeatServerHandler heartbeatServerHandler;

    @Override
    protected void initChannel(Channel channel) throws Exception {
        channel.pipeline().addLast(new IMIdleStateHandler());
        channel.pipeline().addLast(activeChannelHandler);
        channel.pipeline().addLast(new MeterDecodeHandler());
        channel.pipeline().addLast(heartbeatServerHandler);
        channel.pipeline().addLast(meterServerHandler);
        channel.pipeline().addLast(new MeterEncodeHandler());
    }
}
