package com.jpsoft.smart.electricity.server;

import io.netty.bootstrap.ServerBootstrap;
import io.netty.channel.Channel;
import io.netty.channel.ChannelFuture;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.PreDestroy;

@Slf4j
@Component
public class TcpServer {
    @Autowired
    private ServerBootstrap serverBootstrap;

    private Channel serverChannel;

    public void start(int port){
        ChannelFuture channelFuture = serverBootstrap.bind("0.0.0.0",port);

        serverChannel = channelFuture.channel();

        channelFuture.addListener((future)-> {
          if(future.isSuccess()){
              log.warn(String.format("netty 已监听%d端口",port));
          }
        });
    }

    @PreDestroy
    public void stop(){
        if (serverChannel!=null && serverChannel.isOpen()){
            serverChannel.close();
        }
    }
}
