package com.jpsoft.smart.electricity.server.config;

import com.jpsoft.smart.electricity.server.ChannelWrapper;
import com.jpsoft.smart.electricity.server.ServerChannelInitializer;
import io.netty.bootstrap.ServerBootstrap;
import io.netty.channel.nio.NioEventLoopGroup;
import io.netty.channel.socket.nio.NioServerSocketChannel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

@Component
@Configuration
public class ElectricityConfig {
    @Bean(name = "bossGroup", destroyMethod = "shutdownGracefully")
    public NioEventLoopGroup bossGroup(){
        return new NioEventLoopGroup();
    }

    @Bean(name = "workerGroup", destroyMethod = "shutdownGracefully")
    public NioEventLoopGroup workerGroup(){
        return new NioEventLoopGroup();
    }

    @Autowired
    private ServerChannelInitializer customChannelInitializer;

    @Bean(name = "serverBootstrap")
    public ServerBootstrap bootstrap() {
        ServerBootstrap b = new ServerBootstrap();
        b.group(bossGroup(), workerGroup())
                .channel(NioServerSocketChannel.class)
                .childHandler(customChannelInitializer);

        return b;
    }

    @Bean(name="activeChannelMap")
    public Map<String, ChannelWrapper> activeChannelMap(){
        Map<String, ChannelWrapper> channelMap = new ConcurrentHashMap<>();

        return channelMap;
    }
}
