package com.jpsoft.smart.lapi.handler;

import cn.hutool.json.JSONObject;
import com.jpsoft.smart.lapi.dto.HeartReportInfo;
import com.jpsoft.smart.modules.base.service.DeviceInfoService;
import com.jpsoft.smart.modules.base.service.PersonDeviceLogService;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import io.netty.handler.codec.http.FullHttpRequest;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.Date;

@Slf4j
@Component
@ChannelHandler.Sharable
public class HeartReportHandler extends SimpleChannelInboundHandler<HeartReportInfo> {
    @Autowired
    private DeviceInfoService deviceInfoService;

    @Override
    protected void channelRead0(ChannelHandlerContext channelHandlerContext, HeartReportInfo heartReportInfo) throws Exception {

        log.warn(String.valueOf(channelHandlerContext.channel().remoteAddress()));
        log.warn(heartReportInfo.toString());
        String ipAndPort = String.valueOf(channelHandlerContext.channel().remoteAddress());
        String deviceNo = heartReportInfo.getDeviceCode();
        String ip = ipAndPort.substring(ipAndPort.indexOf("/")+1,ipAndPort.indexOf(":"));
        log.warn(deviceNo);
        log.warn("ip =="+ip);

        deviceInfoService.updateByDeviceNo(deviceNo,ip);




    }
}
