package com.jpsoft.smart.lapi.handler;

import cn.hutool.json.JSONObject;
import com.jpsoft.smart.lapi.dto.HeartReportInfo;
import com.jpsoft.smart.lapi.dto.PersonVerification;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import io.netty.handler.codec.http.FullHttpRequest;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.net.SocketAddress;

@Slf4j
@Component
public class ParseRequestHandler extends SimpleChannelInboundHandler<FullHttpRequest> {
    @Override
    protected void channelRead0(ChannelHandlerContext ctx, FullHttpRequest request) throws Exception {
        ByteBuf byteBuf = request.content();

        byteBuf.markReaderIndex();

        byte[] buffer = new byte[byteBuf.readableBytes()];

        for(int i=0;i<buffer.length;i++) {
            buffer[i] = byteBuf.readByte();
        }

        byteBuf.resetReaderIndex();

        log.warn(request.uri());
     //   log.warn(String.valueOf(ctx.channel().remoteAddress()));

        String json = new String(buffer,"UTF-8");

        SocketAddress remoteAddress = ctx.channel().remoteAddress();

        //log.warn(String.format("收到来自%s数据:%s",remoteAddress.toString(), json));

        if(request.uri().contains("HeartReportInfo")) {
            JSONObject jsonObject = new JSONObject(json);
            HeartReportInfo heartReportInfo = jsonObject.toBean(HeartReportInfo.class);

            ctx.fireChannelRead(heartReportInfo);
        }
        else if(request.uri().contains("Notifications")) {
            log.warn("PersonVerification"+request.uri());
            PersonVerification personVerification = new PersonVerification();
            personVerification.setUri(request.uri());

            JSONObject jsonObject = new JSONObject(json);
            personVerification.setJsonObject(jsonObject);

            ctx.fireChannelRead(personVerification);
        }
    }
}