package com.jpsoft.smart.listener;

import com.jpsoft.smart.config.ElectricityParamConfig;
import com.jpsoft.smart.electricity.server.TcpServer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.annotation.WebListener;

@WebListener
@Component
public class WebStateListener implements ServletContextListener {
    @Autowired
    private TcpServer tcpServer;

    @Autowired
    private ElectricityParamConfig electricityParamConfig;

    @Override
    public void contextDestroyed(ServletContextEvent arg0) {
        // TODO Auto-generated method stub
        System.out.println("web应用销毁");

        if(tcpServer!=null) {
            tcpServer.stop();
        }
    }

    @Override
    public void contextInitialized(ServletContextEvent arg0) {
        // TODO Auto-generated method stub
        System.out.println("web应用初始化");

        if(tcpServer!=null) {
            tcpServer.start(electricityParamConfig.getPort());
        }
    }
}