package com.jpsoft.smart;

import com.jpsoft.smart.modules.base.entity.DeviceInfo;
import com.jpsoft.smart.modules.lapi.service.ILapiService;
import com.jpsoft.smart.modules.lapi.vo.LapiMsgResult;
import com.jpsoft.smart.modules.lapi.vo.LapiResult;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.List;

/**
 * @author 墨鱼_mo
 * @date 2020-3-15 9:58
 */
@RunWith(SpringRunner.class)
@SpringBootTest
public class LApiTest {

    @Autowired
    private ILapiService lapiService;

    @Test
    public void testKeepLive(){
        try {
            Boolean result = lapiService.keepAlive("1");
            System.out.println(result);
        } catch (Exception e) {
            e.printStackTrace();
            String message = e.getMessage();
        }

    }

    @Test
    public void testAddPerson(){
        try {

            List<LapiMsgResult> result = lapiService.addPerson(1111L);
            System.out.println(result);
        } catch (Exception e) {
            e.printStackTrace();
            String message = e.getMessage();
        }

    }

    @Test
    public void testGetFaceDB(){
        try {

            DeviceInfo deviceInfo = new DeviceInfo();
            deviceInfo.setIpAddress("192.168.11.13");
            deviceInfo.setPort("80");
            lapiService.getFaceDbId(deviceInfo,"荆鹏软件");
            System.out.println();
        } catch (Exception e) {
            e.printStackTrace();
            String message = e.getMessage();
        }

    }

    @Test
    public void testDeletPerson(){
        try {
            List<LapiMsgResult> result = lapiService.deletePerson(1111L);
            System.out.println(result);
        } catch (Exception e) {
            e.printStackTrace();
            String message = e.getMessage();
        }

    }

    @Test
    public void testRemoteOpened(){
        try {
            Boolean success = lapiService.phoneOpenDoor("4b40b1e3-57b9-4119-828e-9d42d56e5b57");
            System.out.println(success);
        } catch (Exception e) {
            e.printStackTrace();
            String message = e.getMessage();
        }

    }

    @Test
    public void testReBoot(){
        try {
            Boolean success = lapiService.phoneOpenDoor("4b40b1e3-57b9-4119-828e-9d42d56e5b57");
            System.out.println(success);
        } catch (Exception e) {
            e.printStackTrace();
            String message = e.getMessage();
        }

    }

    @Test
    public void testAddLibrary(){
        try {
            List<LapiResult> list = lapiService.addCompanyLib("c6083ba7-6025-11ea-9760-f0761c318e91","4b40b1e3-57b9-4119-828e-9d42d56e5b57");
            System.out.println(list);
        } catch (Exception e) {
            e.printStackTrace();
            String message = e.getMessage();
        }

    }

    @Test
    public void testDeleteLibrary(){
        try {
            LapiResult lapiResult = lapiService.deleteCompanyLib("4b40b1e3-57b9-4119-828e-9d42d56e5b57","1584502940");
            System.out.println(lapiResult);
        } catch (Exception e) {
            e.printStackTrace();
            String message = e.getMessage();
        }

    }
    @Test
    public void testUpdateCompanyLib(){
        try {
            LapiResult lapiResult = lapiService.updateCompanyLib("c6083ba7-6025-11ea-9760-f0761c318e91","4b40b1e3-57b9-4119-828e-9d42d56e5b57","1584429125");
            System.out.println(lapiResult);
        } catch (Exception e) {
            e.printStackTrace();
            String message = e.getMessage();
        }

    }

    @Test
    public void testDeleteDeviceAllCompanyLib(){
        try {
            List<LapiResult> list = lapiService.deleteDeviceAllCompanyLib("4b40b1e3-57b9-4119-828e-9d42d56e5b57");
            System.out.println(list);
        } catch (Exception e) {
            e.printStackTrace();
            String message = e.getMessage();
        }

    }

}
